		-- Example of calling a machine code 
		-- routine from Euphoria

include machine.e


sequence code
atom code_space


code =
      {#50,                            -- push eax
       #53,                            -- push ebx
       #52,                            -- push edx

  #B4,#02,               -- start: mov ah, #2 
  #B2,#07,               -- 	   mov dl, #7 
  #CD,#21,               -- 	   int #21 
  #EB,#F8,               -- 	   jmp start 




       #5A,                            -- pop edx
       #5B,                            -- pop ebx
       #58,                            -- pop eax
       #C3}                            -- ret


code_space = allocate(length(code))
poke(code_space, code)


puts(1, "\n  calling machine code routine ... ")


call(code_space) 

-- You won't get here anyway

free(code_space)

puts(1, "success\n")


